/*  Copyright (C) 2008 Niels Richard Hansen. 

    This file is part of StemSearch.

    StemSearch is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    StemSearch is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef GENOME_INC_GUARD
#define GENOME_INC_GUARD

#include<vector>
#include<string>
#include<iostream>
#include "../matrix/matrix.h"
#include "../random_numbers/random.h"

class Genome
{
	vector<long>  IntGenome;
	char DNAalph1[5];
	char DNAalph2[5];
	char RNAalph1[5];
	char RNAalph2[5];
	string Name;
	bool warnings;
	uni r;
	
	vector<long>* Positions;
	long Value, SegmentSize, Base, TableSize;
	void init_alph();
public:
	Genome(bool=false);
	Genome(vector<long>);
	Genome(char*);
	
	void init(vector<long>);
	void read(char*);
	bool read(istream&,char ='\n');
	long size();
	char DNAalph(long);
	char RNAalph(long);
	long operator[](long);
	string DNAsegment(long, long); 
	string RNAsegment(long, long); 
	string name();
	void matchtable(long =-1, long =0, long =6, long =4);
	long table_lookup(long);
	string inv_table_lookup(long);
	void save_table(char*,char* =" ");
	void warn(bool);
	RectMatrix<double> TP();
	
	void generate(long,vector<double>, long = 1);
	void Markov_generate(long,RectMatrix<double>,long = 1);

};     


#endif //GENOME_INC_GUARD
